export { LICENSE, VERSION } from "./version.js";
export * from "./lib/transformers.js";
export * from "./lib/combiners.js";
export * from "./lib/reducers.js";
export * from "./lib/types.js";
export * from "./lib/effectors.js";
export * as create from "./lib/generators.js";
import * as fp from "./fp.js";
/**
 * Curried functions. Note that only functions which take an iterable as a first
 * argument, and accept more than one argument, are curried.
 */
export const curried = fp;
