"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.lazyObserver = exports.forEach = exports.completeFlat = exports.flat = exports.remember = exports.chunkify = exports.indexedPairs = exports.filter = exports.until = exports.take = exports.map = exports.norm = exports.product = exports.sum = exports.find = exports.every = exports.includes = exports.some = exports.reduce = exports.concat = exports.pair = void 0;
const util_js_1 = require("./lib/internal/util.js");
const combinators = __importStar(require("./lib/combiners.js"));
const reducers = __importStar(require("./lib/reducers.js"));
const transformers = __importStar(require("./lib/transformers.js"));
const effectors = __importStar(require("./lib/effectors.js"));
// Combinators
exports.pair = (0, util_js_1.curryIterFunction)(combinators.pair);
exports.concat = (0, util_js_1.curryIterFunction)(combinators.concat);
// Reducers
exports.reduce = (0, util_js_1.curryIterFunction)(reducers.reduce);
exports.some = (0, util_js_1.curryIterFunction)(reducers.some);
exports.includes = (0, util_js_1.curryIterFunction)(reducers.includes);
exports.every = (0, util_js_1.curryIterFunction)(reducers.every);
exports.find = (0, util_js_1.curryIterFunction)(reducers.find);
exports.sum = reducers.sum;
exports.product = reducers.product;
exports.norm = reducers.norm;
// Transformers
exports.map = (0, util_js_1.curryIterFunction)(transformers.map);
exports.take = (0, util_js_1.curryIterFunction)(transformers.take);
exports.until = (0, util_js_1.curryIterFunction)(transformers.until);
exports.filter = (0, util_js_1.curryIterFunction)(transformers.filter);
exports.indexedPairs = transformers.indexedPairs;
exports.chunkify = (0, util_js_1.curryIterFunction)(transformers.chunkify);
exports.remember = transformers.rememeber;
exports.flat = (0, util_js_1.curryIterFunction)(transformers.flat);
exports.completeFlat = transformers.completeFlat;
// Effectors
exports.forEach = (0, util_js_1.curryIterFunction)(effectors.forEach);
exports.lazyObserver = (0, util_js_1.curryIterFunction)(effectors.lazyObserver);
exports.create = __importStar(require("./lib/generators.js"));
